#include<iostream>
#include<vector>
#include<queue>
#include<limits>
#include<algorithm>
#include<fstream>

using namespace std;

int n, m;
long long int matr[ 301 ][ 301 ];
int g[ 301 ][ 301 ];
bool used[ 301 ];
bool pred[ 301 ][ 301 ];
long long int v[ 301 ];
int roads[ 301 ][ 301 ];
bool cused[ 301 ];

vector< int > ans;

void dijikstra()
{
    used[ 1 ] = 1;
    v[ 1 ] = 0;
    
    long long int m;
    int ci, cj;
    
    do
    {
        m = numeric_limits<long long int>::max();
        ci = -1;
        cj = -1;
        
        for ( int i = 1; i <= n; i++ )
        {
            if ( !used[ i ] )
            {
                for ( int j = 1; j <= n; j++ )
                {
                    if ( used[ j ] )
                    {
                        if ( m > v[ j ] + g[ i ][ j ] )
                        {
                            m = v[ j ] + g[ i ][ j ];
                            ci = i;
                            cj = j;
                        }
                    }
                }
            }
        }
        
        if ( ci != -1 )
        {
            used[ ci ] = 1;
            pred[ ci ][ cj ] = 1;
            pred[ cj ][ ci ] = 1;
            v[ ci ] = m;
        }
    }while( ci > 0 );
}

void dfs( int s )
{
    used[ s ] = 1;
    for ( int i = 1; i <= n; i++ )
    {
        //cout << i << "->" << pred[ s ][ i ] << endl; system("pause");
        if ( pred[ s ][ i ] && !used[ i ] )
        {
            ans.push_back( roads[ s ][ i ] );
            dfs( i );
        }
    }
}

/*bool cities_unused()
{
    for ( int i = 1; i <= n; i++ )
        if ( !cused[ i ] ) return false;
    return true;
}
void find_by_counts()
{
    long long int m;
    int ci, cj;
    while ( !cities_unused() )
    {
        m = numeric_limits<long long int>::min();
        for ( int i = 1; i <= n; i++ )
        {
            for ( int j = i + 1; j <= n; j++ )
            {
                //cout << matr[ i ][ j ] << " ";
                if ( m <= matr[ i ][ j ] )
                {
                    if ( !cused[ j ] )
                    {
                        m = matr[ i ][ j ];
                        ci = i;
                        cj = j;
                    }
                }
            }
            //cout << endl;
        }
        if ( ci > 0 )
        {
            //cout << m << " " << ci << " " << cj << endl;
            construct_ans( ci, cj );
            construct_ans( cj, ci );
        }
    }
}
*/
void print_ans()
{
    fstream fl;
    fl.open( "graph.out", ios::out );
    for ( int i = 0; i < ans.size(); i++ ) fl << ans[ i ] << endl;
    fl.close();
}

int main()
{
    fstream fl;
    fl.open( "graph.in", ios::in );
    
    fl >> n >> m;
    
    int s, f, d;
    memset( g, 64, sizeof( g ) );
    
    for ( int i = 0; i < m; i++ )
    {
        fl >> s >> f >> d;
        roads[ s ][ f ] = i + 1;
        roads[ f ][ s ] = i + 1;
        
        g[ s ][ f ] = d;
        g[ f ][ s ] = d;
    }
    
    for ( int i = 1; i <= n; i++ )
    {
        for ( int j = 1; j <= n; j++ ) fl >> matr[ i ][ j ];
    }
    fl.close();
    dijikstra();
    //for ( int i = 1; i <= n; i++ ) cout << pred[ i ] << endl;
    //cout << "=============" << endl;
    //system("pause");
    //find_by_counts();
    memset( used, 0, sizeof( used ) );
    dfs( 1 );
    print_ans();
    
    //system("pause");
    return 0;
}
/*
5 8
2 1 783
3 2 531
2 4 863
4 3 124
1 5 68
2 5 136
5 3 930
4 5 803
0 315634023 635723059 125898168 628175012
315634023 0 369133070 59961394 656478043
635723059 369133070 0 89018457 131176230
125898168 59961394 89018457 0 653377374
628175012 656478043 131176230 653377374 0
*/
